Index: squid/src/peer_digest.c
diff -u squid/src/peer_digest.c:1.7 squid/src/peer_digest.c:1.2.2.8
--- squid/src/peer_digest.c:1.7	Sat Mar  3 02:44:32 2001
+++ squid/src/peer_digest.c	Sun Mar 18 14:33:32 2001
@@ -269,7 +269,6 @@
     peer *p = pd->peer;
     StoreEntry *e, *old_e;
     char *url;
-    const cache_key *key;
     request_t *req;
     DigestFetchState *fetch = NULL;
 
@@ -283,8 +282,7 @@
 	url = internalRemoteUri(p->host, p->http_port,
 	    "/squid-internal-periodic/", StoreDigestFileName);
 
-    key = storeKeyPublic(url, METHOD_GET);
-    debug(72, 2) ("peerDigestRequest: %s key: %s\n", url, storeKeyText(key));
+    debug(72, 2) ("peerDigestRequest: %s\n", url);
     req = urlParse(METHOD_GET, url);
     assert(req);
 
@@ -308,16 +306,17 @@
     req->flags.cachable = 1;
     /* the rest is based on clientProcessExpired() */
     req->flags.refresh = 1;
-    old_e = fetch->old_entry = storeGet(key);
+    old_e = fetch->old_entry = storeGetPublic(url, METHOD_GET);
     if (old_e) {
 	debug(72, 5) ("peerDigestRequest: found old entry\n");
 	storeLockObject(old_e);
 	storeCreateMemObject(old_e, url, url);
-	fetch->old_sc = storeClientListAdd(old_e, fetch);
+	fetch->old_sc = storeClientRegister(old_e, fetch);
     }
-    e = fetch->entry = storeCreateEntry(url, url, req->flags, req->method);
+    e = fetch->entry = storeCreateEntry(url, url, req->flags, req->method,
+      REPLY_OBJ_NETWORK);
     assert(EBIT_TEST(e->flags, KEY_PRIVATE));
-    fetch->sc = storeClientListAdd(e, fetch);
+    fetch->sc = storeClientRegister(e, fetch);
     /* set lastmod to trigger IMS request if possible */
     if (old_e)
 	e->lastmod = old_e->lastmod;
@@ -366,7 +365,7 @@
 	    httpReplyUpdateOnNotModified(fetch->old_entry->mem_obj->reply, reply);
 	    storeTimestampsSet(fetch->old_entry);
 	    /* get rid of 304 reply */
-	    storeUnregister(fetch->sc, fetch->entry, fetch);
+	    storeClientUnregister(fetch->sc, fetch->entry, fetch);
 	    storeUnlockObject(fetch->entry);
 	    fetch->entry = fetch->old_entry;
 	    fetch->old_entry = NULL;
@@ -377,7 +376,7 @@
 	    /* get rid of old entry if any */
 	    if (fetch->old_entry) {
 		debug(72, 3) ("peerDigestFetchReply: got new digest, releasing old one\n");
-		storeUnregister(fetch->old_sc, fetch->old_entry, fetch);
+		storeClientUnregister(fetch->old_sc, fetch->old_entry, fetch);
 		storeReleaseRequest(fetch->old_entry);
 		storeUnlockObject(fetch->old_entry);
 		fetch->old_entry = NULL;
@@ -685,7 +684,7 @@
 
     if (fetch->old_entry) {
 	debug(72, 2) ("peerDigestFetchFinish: deleting old entry\n");
-	storeUnregister(fetch->sc, fetch->old_entry, fetch);
+	storeClientUnregister(fetch->sc, fetch->old_entry, fetch);
 	storeReleaseRequest(fetch->old_entry);
 	storeUnlockObject(fetch->old_entry);
 	fetch->old_entry = NULL;
@@ -697,7 +696,7 @@
     statCounter.cd.msgs_recv += fetch->recv.msg;
 
     /* unlock everything */
-    storeUnregister(fetch->sc, fetch->entry, fetch);
+    storeClientUnregister(fetch->sc, fetch->entry, fetch);
     storeUnlockObject(fetch->entry);
     requestUnlink(fetch->request);
     fetch->entry = NULL;
@@ -721,7 +720,7 @@
     /* XXX: we must distinguish between 304 hits and misses here */
     fetch->sent.bytes = httpRequestPrefixLen(fetch->request);
     fetch->recv.bytes = fetch->entry->store_status == STORE_PENDING ?
-	mem->inmem_hi : mem->object_sz;
+	storeMemHiOffset(fetch->entry) : mem->object_sz;
     fetch->sent.msg = fetch->recv.msg = 1;
     fetch->expires = fetch->entry->expires;
     fetch->resp_time = squid_curtime - fetch->start_time;
Index: squid/src/protos.h
diff -u squid/src/protos.h:1.20 squid/src/protos.h:1.2.2.19
--- squid/src/protos.h:1.20	Sat Mar  3 02:44:32 2001
+++ squid/src/protos.h	Sun Mar 18 14:33:32 2001
@@ -127,11 +127,12 @@
 extern void clientAccessCheckDone(int, void *);
 extern int modifiedSince(StoreEntry *, request_t *);
 extern char *clientConstructTraceEcho(clientHttpRequest *);
-extern void clientPurgeRequest(clientHttpRequest *);
+extern void clientStartPurgeRequest(clientHttpRequest *);
 extern int checkNegativeHit(StoreEntry *);
 extern void clientHttpConnectionsOpen(void);
 extern void clientHttpConnectionsClose(void);
-extern StoreEntry *clientCreateStoreEntry(clientHttpRequest *, method_t, request_flags);
+extern StoreEntry *clientCreateStoreEntry(clientHttpRequest *, method_t,
+  request_flags, reply_obj_t);
 extern int isTcpHit(log_type);
 extern void clientReadBody(request_t * req, char *buf, size_t size, CBCB * callback, void *data);
 extern int clientAbortBody(request_t * req);
@@ -493,6 +494,7 @@
 extern int httpReplyBodySize(method_t, HttpReply *);
 
 /* Http Request */
+extern void requestInit(void);
 extern request_t *requestCreate(method_t, protocol_t, const char *urlpath);
 extern void requestDestroy(request_t *);
 extern request_t *requestLink(request_t *);
@@ -866,7 +868,8 @@
 extern StoreEntry *new_StoreEntry(int, const char *, const char *);
 extern StoreEntry *storeGet(const cache_key *);
 extern StoreEntry *storeGetPublic(const char *uri, const method_t method);
-extern StoreEntry *storeCreateEntry(const char *, const char *, request_flags, method_t);
+extern StoreEntry *storeCreateEntry(const char *, const char *, request_flags,
+  method_t, reply_obj_t);
 extern void storeSetPublicKey(StoreEntry *);
 extern void storeComplete(StoreEntry *);
 extern void storeInit(void);
@@ -893,6 +896,7 @@
 extern void storeMemObjectDump(MemObject * mem);
 extern void storeEntryDump(const StoreEntry * e, int debug_lvl);
 extern const char *storeUrl(const StoreEntry *);
+extern const char *storeKeyUrl(const StoreEntry *);
 extern void storeCreateMemObject(StoreEntry *, const char *, const char *);
 extern void storeCopyNotModifiedReplyHeaders(MemObject * O, MemObject * N);
 extern void storeBuffer(StoreEntry *);
@@ -918,6 +922,10 @@
 extern void storeFsDone(void);
 extern void storeFsAdd(char *, STSETUP *);
 extern void storeReplAdd(char *, REMOVALPOLICYCREATE *);
+extern off_t storeMemHiOffset(const StoreEntry *); 
+extern off_t storeMemLoOffset(const StoreEntry *);
+extern void storeDetachReply(StoreEntry *);
+extern void storeDoubleCheckRequest(request_t *, char *, method_t);
 
 /* store_modules.c */
 extern void storeFsSetup(void);
@@ -926,6 +934,9 @@
 extern void storeReplSetup(void);
 
 /* store_io.c */
+extern void storeLookup(request_t * , STGETDONE *, void *);
+extern void storeLookupComplete(request_t *, STGETDONE *, void *,
+   StoreEntry *);
 extern storeIOState *storeCreate(StoreEntry *, STFNCB *, STIOCB *, void *);
 extern storeIOState *storeOpen(StoreEntry *, STFNCB *, STIOCB *, void *);
 extern void storeClose(storeIOState *);
@@ -1029,10 +1040,10 @@
 #if STORE_CLIENT_LIST_DEBUG
 extern store_client *storeClientListSearch(const MemObject * mem, void *data);
 #endif
-extern store_client *storeClientListAdd(StoreEntry * e, void *data);
-extern void storeClientCopy(store_client *, StoreEntry *, off_t, off_t, size_t, char *, STCB *, void *);
-extern int storeClientCopyPending(store_client *, StoreEntry * e, void *data);
-extern int storeUnregister(store_client * sc, StoreEntry * e, void *data);
+extern void storeClientRegister(StoreEntry * e, void *data);
+extern void storeClientCopy(StoreEntry *, off_t, off_t, size_t, char *, STCB *, void *);
+extern int storeClientCopyPending(StoreEntry * e, void *data);
+extern int storeClientUnregister(StoreEntry * e, void *data);
 extern off_t storeLowestMemReaderOffset(const StoreEntry * entry);
 extern void InvokeHandlers(StoreEntry * e);
 extern int storePendingNClients(const StoreEntry * e);
@@ -1289,6 +1300,16 @@
 extern unsigned int url_checksum(const char *url);
 #endif
 
+
+/*
+ * reply objects
+ */
+extern void reply_internal_init(void);
+extern void reply_internal_create(StoreEntry *);
+
+extern void reply_network_init(void);
+extern void reply_network_create(StoreEntry *);
+
 /*
  * hack to allow snmp access to the statistics counters
  */
Index: squid/src/reply_internal.c
diff -u /dev/null squid/src/reply_internal.c:1.1.2.6
--- /dev/null	Sun Jan 25 06:36:42 2004
+++ squid/src/reply_internal.c	Wed Jan  3 04:11:33 2001
@@ -0,0 +1,290 @@
+/*
+ * reply_internal.c
+ *
+ * Handles "internal" replies, such as error pages, internal gifs, etc..
+ *
+ * Adrian Chadd <adrian@creative.net.au>
+ */
+
+
+#include "squid.h"
+
+struct _reply_internal_state {
+    mem_hdr data_hdr;
+    off_t inmem_hi;
+    off_t inmem_lo;
+};
+
+
+
+typedef struct _reply_internal_state reply_internal_state_t;
+
+MemPool *reply_internal_state_pool = NULL;
+
+/* Prototypes */
+static void reply_internal_clientcopy(StoreEntry * e);
+static void reply_internal_clientcopy3(StoreEntry * e);
+
+
+
+void
+reply_internal_init(void)
+{
+    reply_internal_state_pool = memPoolCreate("Internal reply pool",
+      sizeof(reply_internal_state_t));
+}
+
+
+/*
+ * reply_internal_done
+ */
+static void
+reply_internal_done(StoreEntry *e)
+{
+    reply_internal_state_t *state = e->stdata;
+
+    /* Make sure noone is left ! */
+
+    /* Kill the state struct */
+    stmemFree(&state->data_hdr);
+    memPoolFree(reply_internal_state_pool, state);
+
+    /* Done! */
+}
+
+
+/*
+ * reply_internal_memhi
+ */
+static off_t
+reply_internal_memhi(const StoreEntry *e)
+{
+    reply_internal_state_t *state = e->stdata;
+
+    return state->inmem_hi;
+}
+
+
+/*
+ * reply_internal_memlo
+ */
+static off_t
+reply_internal_memlo(const StoreEntry *e)
+{
+    reply_internal_state_t *state = e->stdata;
+
+    return state->inmem_lo;
+}
+
+
+/*
+ * reply_internal_append
+ */
+static void
+reply_internal_append(StoreEntry *e, const char *buf, int len)
+{
+    MemObject *mem = e->mem_obj;
+    reply_internal_state_t *state = e->stdata;
+    assert(mem != NULL);
+    assert(len >= 0);
+    assert(e->store_status == STORE_PENDING);
+    if (len) {
+        debug(20, 5) ("storeAppend: appending %d bytes for '%s'\n",
+            len,
+            storeKeyUrl(e));
+        /* Used to call storeGetMemSpace here .. */
+        /* storeGetMemSpace(len); */
+        stmemAppend(&state->data_hdr, buf, len);
+        state->inmem_hi += len;
+    }
+    if (EBIT_TEST(e->flags, DELAY_SENDING))
+        return;
+    e->stflush(e);
+}
+
+
+/*
+ * reply_internal_flush
+ */
+static void
+reply_internal_flush(StoreEntry *e)
+{
+    debug(20, 3) ("reply_internal_flush: %s\n", storeKeyUrl(e));
+    /* walk the entire list looking for valid callbacks */
+    if (e->sc.callback_data == NULL)
+        return;
+    if (e->sc.callback == NULL)
+        return;
+    if (e->sc.flags.disk_io_pending)
+        return;
+    reply_internal_clientcopy3(e);
+}
+
+
+/* store client copy evilness */
+
+static void
+reply_internal_clientcallback(store_client * sc, ssize_t sz)
+{
+    STCB *callback = sc->callback;
+    char *buf = sc->copy_buf;
+    assert(sc->callback);
+    sc->callback = NULL;
+    sc->copy_buf = NULL;
+    if (cbdataValid(sc->callback_data))
+	callback(sc->callback_data, buf, sz);
+}
+
+static void
+reply_internal_clientcopyevent(void *data)
+{
+    StoreEntry *e = data;
+    debug(20, 3) ("reply_internal_clientcopyevent: Running\n");
+    e->sc.flags.copy_event_pending = 0;
+    if (!e->sc.valid)
+	return;
+    reply_internal_clientcopy3(e);
+}
+
+
+/*
+ * This function is used below to decide if we have any more data to
+ * send to the client.  If the store_status is STORE_PENDING, then we
+ * do have more data to send.  If its STORE_OK, then
+ * we continue checking. 
+ * If the length is >= 0, then we compare it to the requested copy
+ * offset.
+ */
+static int
+reply_internal_clientnomoretosend(StoreEntry * e, store_client * sc)
+{
+    if (e->store_status == STORE_PENDING)
+	return 0;
+    assert(objectLen(e) > -1); /* Internal objects will never be swap backed */
+    if (sc->copy_offset < objectLen(e))
+	return 0;
+    return 1;
+}
+
+/* copy bytes requested by the client */
+static void
+reply_internal_clientcopy(StoreEntry * e)
+{
+    store_client *sc = &e->sc;
+    if (EBIT_TEST(e->flags, ENTRY_FWD_HDR_WAIT)) {
+	debug(20, 5) ("reply_internal_clientcopy: returning because ENTRY_FWD_HDR_WAIT set\n");
+	return;
+    }
+    debug(20, 3) ("reply_internal_clientcopy: %s\n", storeKeyUrl(e));
+    assert(sc->callback != NULL);
+    /*
+     * We used to check for ENTRY_ABORTED here.  But there were some
+     * problems.  For example, we might have a slow client (or two) and
+     * the server-side is reading far ahead and swapping to disk.  Even
+     * if the server-side aborts, we want to give the client(s)
+     * everything we got before the abort condition occurred.
+     */
+    reply_internal_clientcopy3(e);
+}
+
+static void
+reply_internal_clientcopy3(StoreEntry * e)
+{
+    store_client *sc = &e->sc;
+    reply_internal_state_t *state = e->stdata;
+    size_t sz;
+
+    sc->flags.store_copying = 1;
+    if (reply_internal_clientnomoretosend(e, sc)) {
+	/* There is no more to send! */
+	reply_internal_clientcallback(sc, 0);
+        goto finish;
+    }
+    if ((e->store_status == STORE_PENDING) &&
+        (sc->copy_offset >= state->inmem_hi)) {
+	/* client has already seen this, wait for more */
+	debug(20, 3) ("reply_internal_clientcopy3: Waiting for more\n");
+        goto finish;
+    }
+
+    if ((sc->copy_offset >= state->inmem_lo) &&
+        (sc->copy_offset < state->inmem_hi)) {
+	/* What the client wants is in memory */
+	debug(20, 3) ("reply_internal_clientcopy3: Copying from memory\n");
+	sz = stmemCopy(&state->data_hdr,
+	    sc->copy_offset, sc->copy_buf, sc->copy_size);
+	reply_internal_clientcallback(sc, sz);
+        goto finish;
+    }
+    /* We shouldn't ever get here! */
+    assert(1 == 0);
+
+finish:
+    sc->flags.store_copying = 0;
+}
+
+
+/*
+ * reply_makepublic - make this object public
+ */
+static void
+reply_internal_makepublic(StoreEntry *e)
+{
+    /* Do nothing */
+}
+
+
+/*
+ * reply_makeprivate - make this object private
+ */
+static void
+reply_internal_makeprivate(StoreEntry *e)
+{
+    /* Do nothing */
+}
+
+
+/*
+ * reply_internal_release - object is being deleted
+ *
+ * Yes, its a no-op for us because all objects are private
+ */
+static void
+reply_internal_release(StoreEntry *e)
+{
+}
+
+
+/*
+ * reply_internal_create - create an internal reply ..
+ */
+void
+reply_internal_create(StoreEntry *e)
+{
+    reply_internal_state_t *state;
+    MemObject *mem;
+
+    assert(e != NULL);
+    assert(e->mem_obj != NULL);
+
+    mem = e->mem_obj;
+
+    /* Create a new state struct */
+    state = memPoolAlloc(reply_internal_state_pool);
+
+    /* Initialise it */
+    e->stdata = state;
+
+    /* Assign our functions .. */
+    e->stappend = reply_internal_append;
+    e->stflush = reply_internal_flush;
+    e->stmemhi = reply_internal_memhi; 
+    e->stmemlo = reply_internal_memlo; 
+    e->stclientcopy = reply_internal_clientcopy;
+    e->stmakeprivate = reply_internal_makeprivate;
+    e->stmakepublic = reply_internal_makepublic;
+    e->strelease = reply_internal_release;
+    e->stdone = reply_internal_done;
+    
+    /* Done! */
+}
Index: squid/src/reply_network.c
diff -u /dev/null squid/src/reply_network.c:1.1.2.2
--- /dev/null	Sun Jan 25 06:36:42 2004
+++ squid/src/reply_network.c	Sun Jan  7 15:22:47 2001
@@ -0,0 +1,296 @@
+/*
+ * reply_network.c
+ *
+ * Handles replies which have a network as a data server.
+ * This module handles limiting the amount of data which is requested
+ * from a server so as to not flood the client, and also writing incoming
+ * data to a backing object if needed.
+ *
+ * Adrian Chadd <adrian@creative.net.au>
+ */
+
+
+#include "squid.h"
+
+struct _reply_network_state {
+    mem_hdr data_hdr;
+    off_t inmem_hi;
+    off_t inmem_lo;
+};
+
+
+
+typedef struct _reply_network_state reply_network_state_t;
+
+MemPool *reply_network_state_pool = NULL;
+
+/* Prototypes */
+static void reply_network_clientcopy(StoreEntry * e);
+static void reply_network_clientcopy3(StoreEntry * e);
+
+
+
+void
+reply_network_init(void)
+{
+    reply_network_state_pool = memPoolCreate("Internal reply pool",
+      sizeof(reply_network_state_t));
+}
+
+
+/*
+ * reply_network_done
+ */
+static void
+reply_network_done(StoreEntry *e)
+{
+    reply_network_state_t *state = e->stdata;
+
+    /* Make sure noone is left ! */
+
+    /* Kill the state struct */
+    stmemFree(&state->data_hdr);
+    memPoolFree(reply_network_state_pool, state);
+
+    /* Done! */
+}
+
+
+/*
+ * reply_network_memhi
+ */
+static off_t
+reply_network_memhi(const StoreEntry *e)
+{
+    reply_network_state_t *state = e->stdata;
+
+    return state->inmem_hi;
+}
+
+
+/*
+ * reply_network_memlo
+ */
+static off_t
+reply_network_memlo(const StoreEntry *e)
+{
+    reply_network_state_t *state = e->stdata;
+
+    return state->inmem_lo;
+}
+
+
+/*
+ * reply_network_append
+ */
+static void
+reply_network_append(StoreEntry *e, const char *buf, int len)
+{
+    MemObject *mem = e->mem_obj;
+    reply_network_state_t *state = e->stdata;
+    assert(mem != NULL);
+    assert(len >= 0);
+    assert(e->store_status == STORE_PENDING);
+    if (len) {
+        debug(20, 5) ("storeAppend: appending %d bytes for '%s'\n",
+            len,
+            storeKeyUrl(e));
+        /* Used to call storeGetMemSpace here .. */
+        /* storeGetMemSpace(len); */
+        stmemAppend(&state->data_hdr, buf, len);
+        state->inmem_hi += len;
+    }
+    if (EBIT_TEST(e->flags, DELAY_SENDING))
+        return;
+    e->stflush(e);
+}
+
+
+/*
+ * reply_network_flush
+ */
+static void
+reply_network_flush(StoreEntry *e)
+{
+    debug(20, 3) ("reply_network_flush: %s\n", storeKeyUrl(e));
+    /* walk the entire list looking for valid callbacks */
+    if (e->sc.callback_data == NULL)
+        return;
+    if (e->sc.callback == NULL)
+        return;
+    if (e->sc.flags.disk_io_pending)
+        return;
+    reply_network_clientcopy3(e);
+}
+
+
+/* store client copy evilness */
+
+static void
+reply_network_clientcallback(store_client * sc, ssize_t sz)
+{
+    STCB *callback = sc->callback;
+    char *buf = sc->copy_buf;
+    assert(sc->callback);
+    sc->callback = NULL;
+    sc->copy_buf = NULL;
+    if (cbdataValid(sc->callback_data))
+	callback(sc->callback_data, buf, sz);
+}
+
+static void
+reply_network_clientcopyevent(void *data)
+{
+    StoreEntry *e = data;
+    debug(20, 3) ("reply_network_clientcopyevent: Running\n");
+    e->sc.flags.copy_event_pending = 0;
+    if (!e->sc.valid)
+	return;
+    reply_network_clientcopy3(e);
+}
+
+
+/*
+ * This function is used below to decide if we have any more data to
+ * send to the client.  If the store_status is STORE_PENDING, then we
+ * do have more data to send.  If its STORE_OK, then
+ * we continue checking. 
+ * If the length is >= 0, then we compare it to the requested copy
+ * offset.
+ */
+static int
+reply_network_clientnomoretosend(StoreEntry * e, store_client * sc)
+{
+    if (e->store_status == STORE_PENDING)
+	return 0;
+    assert(objectLen(e) > -1); /* Internal objects will never be swap backed */
+    if (sc->copy_offset < objectLen(e))
+	return 0;
+    return 1;
+}
+
+/* copy bytes requested by the client */
+static void
+reply_network_clientcopy(StoreEntry * e)
+{
+    store_client *sc = &e->sc;
+    if (EBIT_TEST(e->flags, ENTRY_FWD_HDR_WAIT)) {
+	debug(20, 5) ("reply_network_clientcopy: returning because ENTRY_FWD_HDR_WAIT set\n");
+	return;
+    }
+    debug(20, 3) ("reply_network_clientcopy: %s\n", storeKeyUrl(e));
+    assert(sc->callback != NULL);
+    /*
+     * We used to check for ENTRY_ABORTED here.  But there were some
+     * problems.  For example, we might have a slow client (or two) and
+     * the server-side is reading far ahead and swapping to disk.  Even
+     * if the server-side aborts, we want to give the client(s)
+     * everything we got before the abort condition occurred.
+     */
+    reply_network_clientcopy3(e);
+}
+
+static void
+reply_network_clientcopy3(StoreEntry * e)
+{
+    store_client *sc = &e->sc;
+    reply_network_state_t *state = e->stdata;
+    size_t sz;
+
+    sc->flags.store_copying = 1;
+    if (reply_network_clientnomoretosend(e, sc)) {
+	/* There is no more to send! */
+	reply_network_clientcallback(sc, 0);
+        goto finish;
+    }
+    if ((e->store_status == STORE_PENDING) &&
+        (sc->copy_offset >= state->inmem_hi)) {
+	/* client has already seen this, wait for more */
+	debug(20, 3) ("reply_network_clientcopy3: Waiting for more\n");
+        goto finish;
+    }
+
+    if ((sc->copy_offset >= state->inmem_lo) &&
+        (sc->copy_offset < state->inmem_hi)) {
+	/* What the client wants is in memory */
+	debug(20, 3) ("reply_network_clientcopy3: Copying from memory\n");
+	sz = stmemCopy(&state->data_hdr,
+	    sc->copy_offset, sc->copy_buf, sc->copy_size);
+        state->inmem_lo = sc->copy_offset + sz;
+        assert(state->inmem_lo <= state->inmem_hi);
+        stmemFreeDataUpto(&state->data_hdr, state->inmem_lo - 1); 
+	reply_network_clientcallback(sc, sz);
+        goto finish;
+    }
+    /* We shouldn't ever get here! */
+    assert(1 == 0);
+
+finish:
+    sc->flags.store_copying = 0;
+}
+
+
+/*
+ * reply_makepublic - make this object public
+ */
+static void
+reply_network_makepublic(StoreEntry *e)
+{
+    /* Do nothing */
+}
+
+
+/*
+ * reply_makeprivate - make this object private
+ */
+static void
+reply_network_makeprivate(StoreEntry *e)
+{
+    /* Do nothing */
+}
+
+
+/*
+ * reply_network_release - object is being deleted
+ *
+ * Yes, its a no-op for us because all objects are private
+ */
+static void
+reply_network_release(StoreEntry *e)
+{
+}
+
+
+/*
+ * reply_network_create - create an internal reply ..
+ */
+void
+reply_network_create(StoreEntry *e)
+{
+    reply_network_state_t *state;
+    MemObject *mem;
+
+    assert(e != NULL);
+    assert(e->mem_obj != NULL);
+
+    mem = e->mem_obj;
+
+    /* Create a new state struct */
+    state = memPoolAlloc(reply_network_state_pool);
+
+    /* Initialise it */
+    e->stdata = state;
+
+    /* Assign our functions .. */
+    e->stappend = reply_network_append;
+    e->stflush = reply_network_flush;
+    e->stmemhi = reply_network_memhi; 
+    e->stmemlo = reply_network_memlo; 
+    e->stclientcopy = reply_network_clientcopy;
+    e->stmakeprivate = reply_network_makeprivate;
+    e->stmakepublic = reply_network_makepublic;
+    e->strelease = reply_network_release;
+    e->stdone = reply_network_done;
+    
+    /* Done! */
+}
Index: squid/src/stat.c
diff -u squid/src/stat.c:1.9 squid/src/stat.c:1.2.2.10
--- squid/src/stat.c:1.9	Sat Mar  3 02:44:32 2001
+++ squid/src/stat.c	Sun Mar 18 14:33:32 2001
@@ -40,9 +40,9 @@
 
 typedef int STOBJFLT(const StoreEntry *);
 typedef struct {
-    StoreEntry *sentry;
-    int bucket;
-    STOBJFLT *filter;
+    StoreEntry *sentry;		/* Where we're outputting to */
+    STOBJFLT *filter;		/* Filter function for output */
+    StoreEntry *cur_entry;	/* Current StoreEntry being checked .. */
 } StatObjectsState;
 
 /* LOCALS */
@@ -230,8 +230,6 @@
 	strcat(buf, "FWD_HDR_WAIT,");
     if (EBIT_TEST(flags, ENTRY_NEGCACHED))
 	strcat(buf, "NEGCACHED,");
-    if (EBIT_TEST(flags, ENTRY_VALIDATED))
-	strcat(buf, "VALIDATED,");
     if (EBIT_TEST(flags, ENTRY_BAD_LENGTH))
 	strcat(buf, "BAD_LENGTH,");
     if (EBIT_TEST(flags, ENTRY_ABORTED))
@@ -257,10 +255,8 @@
 statStoreEntry(StoreEntry * s, StoreEntry * e)
 {
     MemObject *mem = e->mem_obj;
-    int i;
     struct _store_client *sc;
-    dlink_node *node;
-    storeAppendPrintf(s, "KEY %s\n", storeKeyText(e->hash.key));
+    storeAppendPrintf(s, "KEY %s\n", storeKeyUrl(e));
     if (mem)
 	storeAppendPrintf(s, "\t%s %s\n",
 	    RequestMethodStr[mem->method], mem->log_url);
@@ -274,18 +270,12 @@
     storeAppendPrintf(s, "\tSwap Dir %d, File %#08X\n",
 	e->swap_dirn, e->swap_filen);
     if (mem != NULL) {
-	storeAppendPrintf(s, "\tinmem_lo: %d\n", (int) mem->inmem_lo);
-	storeAppendPrintf(s, "\tinmem_hi: %d\n", (int) mem->inmem_hi);
-	storeAppendPrintf(s, "\tswapout: %d bytes queued\n",
-	    (int) mem->swapout.queue_offset);
-	if (mem->swapout.sio)
-	    storeAppendPrintf(s, "\tswapout: %d bytes written\n",
-		(int) storeOffset(mem->swapout.sio));
-	for (i = 0, node = mem->clients.head; node; node = node->next, i++) {
-	    sc = (store_client *) node->data;
-	    if (sc->callback_data == NULL)
-		continue;
-	    storeAppendPrintf(s, "\tClient #%d, %p\n", i, sc->callback_data);
+	storeAppendPrintf(s, "\tInMem_LoOffset: %d\n", (int) storeMemLoOffset(e));
+	storeAppendPrintf(s, "\tInMem_HiOffset: %d\n", (int) storeMemHiOffset(e));
+
+        sc = &e->sc;
+        if (sc->valid) {
+	    storeAppendPrintf(s, "\tClient #%d, %p\n", 1, sc->callback_data);
 	    storeAppendPrintf(s, "\t\tcopy_offset: %d\n",
 		(int) sc->copy_offset);
 	    storeAppendPrintf(s, "\t\tseen_offset: %d\n",
@@ -305,20 +295,18 @@
     storeAppendPrintf(s, "\n");
 }
 
+#define MAX_NUMOBJECTS_TO_SCAN		1000
+
 /* process objects list */
 static void
 statObjects(void *data)
 {
     StatObjectsState *state = data;
     StoreEntry *e;
-    hash_link *link_ptr = NULL;
-    hash_link *link_next = NULL;
-    if (state->bucket >= store_hash_buckets) {
-	storeComplete(state->sentry);
-	storeUnlockObject(state->sentry);
-	cbdataFree(state);
-	return;
-    } else if (EBIT_TEST(state->sentry->flags, ENTRY_ABORTED)) {
+    int i;
+
+
+    if (EBIT_TEST(state->sentry->flags, ENTRY_ABORTED)) {
 	storeUnlockObject(state->sentry);
 	cbdataFree(state);
 	return;
@@ -326,17 +314,33 @@
 	eventAdd("statObjects", statObjects, state, 0.1, 1);
 	return;
     }
+
+    /* Don't return the data to the client immediately */
     storeBuffer(state->sentry);
-    debug(49, 3) ("statObjects: Bucket #%d\n", state->bucket);
-    link_next = hash_get_bucket(store_table, state->bucket);
-    while (NULL != (link_ptr = link_next)) {
-	link_next = link_ptr->next;
-	e = (StoreEntry *) link_ptr;
-	if (state->filter && 0 == state->filter(e))
-	    continue;
-	statStoreEntry(state->sentry, e);
+
+    for (i = 0; i < MAX_NUMOBJECTS_TO_SCAN; i++) {
+        /* Assume we were given a non-NULL object .. */
+        e = state->cur_entry;
+        assert(e != NULL);
+        if (state->filter) {
+            if (state->filter(e))
+                statStoreEntry(state->sentry, e);
+        } else
+            statStoreEntry(state->sentry, e);
+        storeUnlockObject(e);
+
+        /* Make sure we have a next object .. */
+        if (e->node.next == NULL) {
+            storeComplete(state->sentry);
+            storeUnlockObject(state->sentry);
+            cbdataFree(state);
+            return;
+        }
+        /* e becomes this if we get to the top of the loop again! */
+        state->cur_entry = (StoreEntry *) e->node.next->data;
+        storeLockObject(state->cur_entry);
     }
-    state->bucket++;
+
     eventAdd("statObjects", statObjects, state, 0.0, 1);
     storeBufferFlush(state->sentry);
 }
@@ -348,6 +352,9 @@
     state = cbdataAlloc(StatObjectsState);
     state->sentry = sentry;
     state->filter = filter;
+    state->cur_entry = (StoreEntry *) store_list.head->data;
+    /* This is so it doesn't get riped out from beneath us! */
+    storeLockObject(state->cur_entry);
     storeLockObject(sentry);
     eventAdd("statObjects", statObjects, state, 0.0, 1);
 }
@@ -376,8 +383,10 @@
 {
     if (e->mem_obj == NULL)
 	return 0;
+#if 0
     if (e->mem_obj->swapout.sio == NULL)
 	return 0;
+#endif
     return 1;
 }
 
